/*
qlstuff file for scm, ported from my xlisp qlstuff
jcall from qptr disc from c68v2 distribution
 Richard Zidlicky 1993
*/

#include "scm.h"
#include <stdio.h>
#include <qlib.h>
#include <fcntl.h>

SCM  k_or,k_xor;
SCM  k_sctop,k_scbot,k_cline,k_rline;
SCM  k_vert,k_horiz;

struct PENPOS{	int x,y;  };
SCM  crcoarc();
SCM  dromv();
long  my_conread(struct UFB *,void *,unsigned int);


long _MNEED=200*1024L	       ;
long _STACK=25*1024L	        ;    /* should be enough for most aplications */
long _memincr=10*1024L	       ;
char _PROG_NAME[]="scheme";

int ints_flag=0;
long (*_conread)()= my_conread;
void (*_consetup)()= NULL;

extern alarmjob(),oscheckjob();
static char icheckname[]="scheme interrupt checker";
static char alarmname[]="scheme alarm";


double alarm(i)
      double i;
{
      int tck;
      SCM ticks;
      char *qdt="qdos-ticks";
      if(i){
        ticks=CDR(intern(qdt,(sizet)strlen(qdt)));
        tck=(int)(i*(INUMP(ticks) ? INUM(ticks) : 50));

        jcall(alarmjob,alarmname,10,200,2,tck/32767,tck % 32767);
        }
      return i;
}

void oschmenu(){ints_flag=INT_SIGNAL;}
#if 0
void oschmenu()     /* level 0 i/o used here to avoid problems        */
{    /* with not reentrant code      */
  char *menu=" Keyboard interrupt:\nF1  top-level/SIGINT\n ESC";
  unsigned char qc;
  chanid_t chan=io_open("con_150x40a156x28_1",0);
  if(chan<0){         /* could be only memory overflow        */
      ints_flag=INT_SIGNAL;
      return ;}
  sd_bordr(chan,-1L,4,2);
  sd_clear(chan,-1L);
  sd_setin(chan,-1L,7);
  io_sstrg(chan,-1L,menu,strlen(menu));
  for(;;){
     sd_pos(chan,-1L,0,0);
     io_fbyte(chan,-1L,(void *)&qc);
     switch(qc){
        case 232 : ints_flag=INT_SIGNAL; break;
        case  27 : break;
        default  : continue;
               }
       break;
  }
  io_close(chan);
}
#endif

void poll_routine()
{
      int intr=ints_flag;
      ints_flag=0;

      if (intr) 
        if(intr != handle_it(intr))
           wta(UNDEFINED,(char *) intr, "");
}

/*
#define MYASSERT(_cond,_arg,_pos,_subr) \
          if(!(_cond))wta(_arg,(char *)_pos,_subr); */

static int arg_n;

int moreargs(args)
      SCM args;
{
      if CONSP(args) return (args != EOL);
        else return 0;
}

int gint(args,fun)
      SCM *args;
      char *fun;
{
      SCM num;

/* printf("enter gint\n");
   iprin1(*args,STREAM(def_outp),1);
   lputc('\n',STREAM(def_outp)); */

      if (!moreargs(*args))
        printf("to few arguments or bad subr type in/of %s\n",fun);
      ASSERT( CONSP( *args )&& *args!=EOL ,*args,arg_n,fun);

      num=CAR( *args ); *args=CDR( *args );
      ++arg_n;

      ASSERT(INUMP(num),num,arg_n,fun);
      return INUM(num);
}

chanid_t fchan(args,fun)
      SCM *args;
      char *fun;
{
      SCM fle;
      FILE *stream=stdout;
      arg_n=0;

      if ( moreargs(*args))
        {
         fle=CAR( *args );
         if (PORTP(fle))
           {
            *args=CDR( *args );
            stream=STREAM(fle);
            ++arg_n;}
        }

      fflush(stream);
      return fgetchid(stream);
}


char s_getkey[] ="get-key";
SCM  xgetkey(arglist)
      SCM arglist;
{
          chanid_t chid=fchan(&arglist,s_getkey);
          int  err, tmout=-1;
          unsigned char  qc;
          if (moreargs(arglist))
             tmout=gint(&arglist,s_getkey);
          err=io_fbyte(chid,tmout,(void *)&qc);
          return MAKICHR(err ? err : qc );
}

char s_gotoxy[]="goto-xy";
SCM  xsetpos(arglist)
      SCM arglist;
{
	  chanid_t chid=fchan(&arglist,s_gotoxy);
   int x=gint(&arglist,s_gotoxy),y=gint(&arglist,s_gotoxy);
	  return(MAKINUM(sd_pos(chid,-1L,x,y )));
}

char s_setgpos[]="setgpos";
SCM  xsetgpos(arglist)
      SCM arglist;
{
	  chanid_t chid=fchan(&arglist,s_setgpos);
	  int gx=gint(&arglist,s_setgpos),
       gy=gint(&arglist,s_setgpos),
       x =gint(&arglist,s_setgpos),
       y =gint(&arglist,s_setgpos);
	  return MAKINUM(sd_igcur(chid,-1L,y,x,gy,gx));
}

char s_setmode[]="screen-mode";
SCM  xwmode(arglist)  /* screen write mode  (NORMAL PAINT XOR)*/
      SCM arglist;
{	  SCM mde;
	  short md;
	  chanid_t chid=fchan(&arglist,s_setmode);
	  mde=(moreargs(arglist) ? CAR(arglist) : 0);
	  md=0;
	  if(k_xor==mde) md=-1;
	  if(k_or ==mde) md= 1;
	  return(MAKINUM(sd_setmd(chid,-1,md)));
}

char s_scale[]="scale";
SCM  xscale(arglist)
      SCM arglist;
{
	  chanid_t chid=fchan(&arglist,s_scale);
	  int sca,x,y;
	  sca=gint(&arglist,s_scale),
   x=gint(&arglist,s_scale),y=gint(&arglist,s_scale);
	  return MAKINUM(sd_iscale(chid,-1L,sca,x,y));
}

char s_wdef[]="wdef";
SCM  xwdef(arglist)
      SCM arglist;
{
	  chanid_t chid;
	  int	  bc,bw;
	  struct QLRECT rct;
	  chid=fchan(&arglist,s_wdef);
	  bc=gint(&arglist,s_wdef);
	  bw=gint(&arglist,s_wdef);
	  rct.q_width=gint(&arglist,s_wdef);
	  rct.q_height=gint(&arglist,s_wdef);
	  rct.q_x=gint(&arglist,s_wdef);
	  rct.q_y=gint(&arglist,s_wdef);
	  return MAKINUM(sd_wdef(chid,-1L,bc,bw,&rct));
}

char s_scroll[]="scroll";
SCM  xscroll(arglist)
      SCM arglist;
{
	  SCM richt;
	  SCM scrspec;
	  int  (*scfun)();
	  int  dist;
	  chanid_t chid=fchan(&arglist,s_scroll);
	  dist=gint(&arglist,s_scroll);
	  scfun=sd_scrol;
	  if(moreargs(arglist))
	      richt=CAR(arglist); arglist=CDR(arglist);
	      scrspec=(moreargs(arglist) ? CAR(arglist) : richt);
	      if(richt==k_horiz) scfun=sd_pan;
	      if(scrspec==k_sctop) scfun=sd_scrtp;
	      else
		 if(scrspec==k_scbot) scfun=sd_scrbt;
		 else
		    if(scrspec==k_cline) scfun=sd_panln;
		    else
		       if(scrspec==k_rline) scfun=sd_panrt;
	  return MAKINUM((*scfun)(chid,-1L,dist));
}

char s_clear[]="cls";
SCM  xclear(arglist)
      SCM arglist;
{
	  SCM scrspec;
	  int (*clfun)();
	  chanid_t chid=fchan(&arglist,s_clear);
	  clfun=sd_clear;
	  if(moreargs(arglist))
		 scrspec=CAR(arglist); arglist=CDR(arglist);
		 if(scrspec==k_sctop) clfun=sd_clrtp;
		    else
		      if(scrspec==k_scbot) clfun=sd_clrbt;
			else
			  if(scrspec==k_cline) clfun=sd_clrln;
			    else
			      if(scrspec==k_rline)  clfun=sd_clrrt;
	  return MAKINUM((*clfun)(chid,-1L));
}

char s_color[]="color";
SCM  xcolor(arglist)
      SCM arglist;
{
	  chanid_t chid;
	  chid=fchan(&arglist,s_color);
	  return MAKINUM(sd_setin(chid,-1L,gint(&arglist,s_color)));
}

char s_paper[]="paper";
SCM  xpaper(arglist)
      SCM arglist;
{
	  chanid_t chid;
	  chid=fchan(&arglist,s_paper);
	  return(MAKINUM(sd_setpa(chid,-1L,gint(&arglist,s_paper))));
}

char s_circle[]="circle",s_arc[]="arc";
SCM  xcircle(arglist)
      SCM arglist;
{return crcoarc(sd_ielipse,arglist,s_circle);}
SCM  xarc(arglist) 
      SCM arglist;
{return crcoarc(sd_iarc,arglist,s_arc)   ;}

SCM  crcoarc(afun,arglist,s_fun)
	  int	(*afun)();
      SCM arglist;
      char *s_fun;
{
	  chanid_t chid=fchan(&arglist,s_fun);
	  int i,x[5];
	  for(i=0;i<5;i++) 
          x[i]=(moreargs(arglist) ? gint(&arglist,s_fun) : 0 );
	  return MAKINUM((*afun)(chid,-1L,x[0],x[1],x[2],x[3],x[4]));
}				      /* swap 2<->3 in circle */

char s_move[]="move",s_draw[]="draw";
SCM  xmove(arglist)
      SCM arglist;
 { return dromv(-1L,0L,arglist,s_move); }
SCM  xdraw(arglist)
      SCM arglist;
 { return dromv(0,0,arglist,s_draw) ;   }

char s_moverel[]="moverel",s_drawrel[]="drawrel";
SCM  xmoverel(arglist)
      SCM arglist;
 { return dromv(-1L,-1L,arglist,s_moverel); }
SCM  xdrawrel(arglist)
      SCM arglist;
 { return dromv(0,-1L,arglist,s_drawrel) ;  }

/*#define gprp(sim)  \
     (fixp(prop=(xlgetprop(flesym,sim))) ? getfixnum(prop) : 0) */

SCM dromv(mve_flag,rel_flag,arglist,s_fun)
	  char rel_flag;
	  char mve_flag;
      SCM arglist;
      char *s_fun;
{
	  chanid_t chid;
	  static struct PENPOS PenPos;
	  int x,y,rtval=0;
	  chid=fchan(&arglist);
/*	  PenPos.x=gprp(flesym,grk_x);
  	  PenPos.y=gprp(flesym,grk_y); */
	  do{
	     x=gint(&arglist,s_fun)+(rel_flag ? PenPos.x : 0);
	     y=gint(&arglist,s_fun)+(rel_flag ? PenPos.y : 0);
	     if(~mve_flag) rtval=sd_iline(chid,-1L,PenPos.x,PenPos.y,x,y);
	       else mve_flag=0;
	     PenPos.x=x;
	     PenPos.y=y;
	  }while(moreargs(arglist));
/*	  xlputprop(flesym,MAKINUM(PenPos.x),grk_x);
  	  xlputprop(flesym,MAKINUM(PenPos.y),grk_y); */
	  return MAKINUM(rtval);
}



static iproc qllsubrs[] = {
  {s_getkey,xgetkey},
  {s_gotoxy,xsetpos},
  {s_setgpos,xsetgpos},
  {s_setmode,xwmode},
  {s_scale,xscale},
  {s_wdef,xwdef},
  {s_scroll,xscroll},
  {s_clear,xclear},
  {s_color,xcolor},
  {s_paper,xpaper},
  {s_circle,xcircle},
  {s_arc,xarc},
  {s_move,xmove},
  {s_draw,xdraw},
  {s_moverel,xmoverel},
  {s_drawrel,xdrawrel},

  {0,0}};

SCM keyintern(keyname)   /* there is no way to protect a symbol in scheme */
char *keyname;
{
     SCM  buck;
     buck = sysintern(keyname,UNDEFINED);
     CDR(buck)=CAR(buck);
     return CAR(buck);
}

void init_qlstuff()
{
  k_or    = keyintern(":paint");
  k_xor   = keyintern(":xor");
  k_sctop = keyintern(":scr-top");
  k_scbot = keyintern(":scr-bot");
  k_cline = keyintern(":scr-cln");
  k_rline = keyintern(":scr-rln");
  k_horiz = keyintern(":horiz");
  k_vert  = keyintern(":vert");

  init_iprocs(qllsubrs,tc7_lsubr);
  add_feature("GRAPHIC");

  jcall(oscheckjob,icheckname,10,200,0);
}


long my_conread(sufb,lbuf,lbsize)       /* should do some checking */
struct UFB *sufb;
char *lbuf;
unsigned int lbsize;
{
          return io_fline(sufb->ufbfh,-1L,lbuf,lbsize);
}

